/*
    Copyright 2004,2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>



#define VER         "0.1.1a"
#define KEYPATH     "Software\\Ipswitch\\Messenger Server\\Domains"
#define BUFFSZ      4096



unsigned char *iim_pwd(unsigned char *data, int len);



int main(void) {
    HKEY    key,
            keyvalue,
            keypwd;
    u_char  keybuff[sizeof(KEYPATH) + BUFFSZ],
            buff[BUFFSZ + 1],
            value[BUFFSZ + 1],
            *ptr;
    int     bufflen,
            valuelen,
            len,
            k,
            v;


    setbuf(stdout, NULL);

    fputs("\n"
        "IpSwitch Instant Messaging server passwords decoder "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(RegOpenKeyEx(HKEY_LOCAL_MACHINE, KEYPATH, 0, KEY_READ, &key)) {
        fputs("\n"
            "Error: registry key has not been found\n"
            "\n"
            "    Press RETURN to exit\n", stdout);
        fgetc(stdin);
        exit(1);
    }

    strcpy(keybuff, KEYPATH);
    ptr = keybuff + sizeof(KEYPATH) - 1;
    *ptr++ = '\\';
    k = 0;
    while(1) {
        bufflen = BUFFSZ;
        if(RegEnumKeyEx(
            key,
            k++,
            ptr,
            (void *)&bufflen,
            NULL,
            NULL,
            NULL,
            NULL)) break;

        printf("\n"
            "----------------------\n"
            "Domain:   %s\n"
            "----------------------\n", ptr);

        strcpy(ptr + bufflen, "\\Users");
        len = strlen(keybuff);

        RegOpenKeyEx(HKEY_LOCAL_MACHINE, keybuff, 0, KEY_READ, &keyvalue);
        v = 0;
        while(1) {
            bufflen = BUFFSZ;
            if(RegEnumKeyEx(
                keyvalue,
                v++,
                buff,
                (void *)&bufflen,
                NULL,
                NULL,
                NULL,
                NULL)) break;
            printf("\n  Username:   %s\n", buff);

                /* possible bof but this is a pwd rec not a server 8-) */
            memmove(buff + len + 1, buff, bufflen);
            memcpy(buff, keybuff, len);
            buff[len] = '\\';
            buff[len + bufflen + 1] = 0;

            RegOpenKeyEx(HKEY_LOCAL_MACHINE, buff, 0, KEY_READ, &keypwd);
            valuelen = BUFFSZ;
            if(RegQueryValueEx(
                keypwd,
                "Password",
                NULL,
                NULL,
                value,
                (void *)&valuelen)) continue;

            printf("  Password:   %s\n", iim_pwd(value, valuelen));
            RegCloseKey(keypwd);
        }
        RegCloseKey(keyvalue);
    }
    RegCloseKey(key);

    fputs("\n\n   Press RETURN to exit\n", stdout);
    fgetc(stdin);
    return(0);
}



unsigned char *iim_pwd(unsigned char *data, int len) {
    unsigned char   *ret;
    unsigned int    tmp;

    if(*data != 0xff) return(data);
    ret = ++data;
    len--;
    while(len--) {
        tmp = *data ^ 0x55;
        *data++ = (tmp << 4) | (tmp >> 4);
    }
    *data = 0;
    return(ret);
}


